# RedHalo Max to Blender
***
### 插件说明：
  现阶段3ds Max的资产庞大，对于像我这种从3ds Max转到Blender用户来说，转换3ds Max场景来说还是比较常用用到的功能，为了更加方便的转换3ds Max场景，所以开发了自用的插件。
***
## 特性：
##### 1. 可转换材质
  + <kbd>Max标准材质 *Standard Material*</kbd>
  + <kbd>VRay标准材质 *VRayMtl*</kbd>
  + <kbd>VRay双面材质 *VRay2SidedMtl*</kbd>
  + <kbd>VRay混合材质 *VRayBendMtl*</kbd>
  + <kbd>VRay灯光材质 *VrayLightMtl*</kbd>
  + <kbd>VRay覆盖材质 *VRayOverrideMtl*</kbd> --> *只保留基础材质*
  + <kbd>VRay包裹材质 *VrayMtlWrapper*</kbd> --> *只保留基础材质*
  + <kbd>VRay车漆材质 *VrayCarPaintMtl*</kbd> --> *转换基础金属材质，去除闪光片*
  + <kbd>VRay车漆材质2 *VrayCarPaintMtl2*</kbd> --> *转换基础金属材质，去除闪光片*
  + <kbd>Max双面材质 *DoubleSided*</kbd>
  + <kbd>Corona标准材质 *CoronaMtl*</kbd>
  + <kbd>Corona物理材质 *CoronaPhysicalMtl*</kbd>
  + <kbd>Corona灯光材质 *CoronaLightMtl*</kbd>
  + <kbd>Corona灯光切换材质 *CoronaRaySwitchMtl*</kbd>  --> *只保留基础材质*
##### 2. 贴图/纹理
  + <kbd>位图 *Bitmap*</kbd> 
  + <kbd>棋盘格 *Checker*</kbd> 
  + <kbd>砖块 *Brick*</kbd> 
  + <kbd>混合纹理 *Mix*</kbd> 
  + <kbd>颜色校正 *ColorCorrect*</kbd>   *实现基础调色*
  + <kbd>RGB相乘 *RGBMultiply*</kbd> 
  + <kbd>渐变纹理</kbd>  *Blender不支持贴图，所以只保留颜色,并渲染成一成贴图使用*
  + <kbd>剃度渐变纹理</kbd> *Blender不支持贴图，所以只保留颜色,并渲染成一成贴图使用*
  + <kbd>平铺 *Tiles*</kbd> *部分完成，好多选项blender没找到对应选项*
  + <kbd>颜色纹理 *Color*</kbd> 
  + <kbd>顶点颜色 *Vectex Color*</kbd> 
  + <kbd>VRay位图 *VRayBitmap*</kbd> 
  + <kbd>VRay凹凸转法线</kbd> 
  + <kbd>VRay颜色转法线</kbd> 
  + <kbd>Vray合成纹理</kbd> 
  + <kbd>VRay污垢（AO）</kbd> 
  + <kbd>VRay法线贴图</kbd> 
  + <kbd>VRay颜色纹理</kbd> 
  + <kbd>CoronaAO</kbd> 
  + <kbd>Corona混合</kbd> 
  + <kbd>Corona颜色校正 *Conora ColorCorrect*</kbd> 
  + <kbd>Corona法线 *CoronaNormal*</kbd> 
  + <kbd>Corona法线转换 *CoronaNormalConvert*</kbd> 
  + <kbd>Corona正反面材质 *CoronaFrontBack*</kbd> 
  + <kbd>Corona位图 *CoronaBitmap</kbd>
  + <kbd>衰减 *Falloff*</kbd> *只还原了常用的2种模式*
  + <kbd>合成纹理 *Composition*</kbd> *去除Blender部分不支持的图层混合模式*
 
##### 3. 导出渲染尺寸
##### 4. 导出灯光【无动画】，包括IES，
##### 5. 导出相机【无动画】
##### 6. 物体的其它属性，相机不可见， 是否产生阴影等

#### 已知问题：
+ 一定要安装对应材质的渲染器，比如VRay或Corona。如果只安装其中一个，提示可能无法正常转换的窗口还会弹出，因为高版本开始，VRay和Corona的标准材质可以互相读取。
+ VRay和Corona渲染器一定要是**英文原版**，不要安装汉化版（VRay 6+自带中文界面，跟随max的主界面语言），可以不用破解，转换不受影响。
+ 自从Max2022开始，max添加了安全检测功能，因此要关闭 `禁用第三方脚本动行` 的选项，否则可能无法正常导出。
  选项位于 菜单`Customize自定义` > `Preference用户设置` > `Scurity安全`选项卡，关闭此选项 `Enable Safe Scene Script Execution 启用安全场景脚本执行` 
+ 如果Blender自动导入的出错， 可以在 `%temp%\RH_M2B_TEMP` 目录下查看错误的log文件

***
## 安装步骤：
##### 3ds Max
  1. 把下载后的 `M2B_Installer_Vx.x.mzp` 直接拖放到 3ds max窗口中安装.
  2. 用户自定义设置里面设置自己需要的菜单或快捷键
  3. 如果想使用导出中的 `快速模式`， 需要安装对应的官方USD插件。
    解压 `USD 0.4.0 for 3ds Max 2022-2024.rar` ,安装对应3ds Max版本的USD插件。 
  4. 如果无法正常自动安装，手动复制到以下文件中，然后手动指定菜单或快捷键
      1. 把下载后的 `M2B_Installer_Vx.x.mzp` 的 `.mzp` 后缀名修改为zip后，解压
      2. 复制文件夹中的 `Max2Blender` 到以下目录          
        目录 `%localappdata%\Autodesk\3dsMax` > `Max版本（比如 2023 - 64bit）` > `ENU - 英文版`或`CHS - 中文版` > `scripts`, 比如：`%localappdata%\Autodesk\3dsMax\2023 - 64bit\ENU\scripts`
      3. 复制文件夹中的 `Icons` 和 `IconsDark` 到以下目录，如果提示覆盖，点确定
        目录 `3dsMax安装目录` > `UI_ln`


##### Blender
  1. 在插件管理下正常安装插件 `M2B_Installer_Vx.x.zip`
  2. 从`File文件` > `Import导入` > `3Ds Max File Importer(*.max)`调用插件

## 使用说明：
1. 3ds Max端
  + <kbd>快速模式</kbd>

    此模式下，导出和Blender导入速度比较快，但是对软件的版本要求比较高。如果Blender版本低于3.5，Blender可能无法正常导入模型

  + <kbd>兼容模式</kbd>

    此模式下，导出和Blender导入速度比较慢，但是兼容性比较高。适用于所有版本

  + <kbd>所有物体</kbd> 

    把场景中所有物体合部导出

  + <kbd>选择物体</kbd> 

    只导出选择物体

  + <kbd>导出</kbd> 

    导出

2. Blender端
  + 安装完成后，打开插件的属性，添加3ds Max的安装目录，以便不用打开3ds Max软件也可以导入3ds Max场景
  + 导入窗口参数
    1. Import format 导入格式

        + <kbd>Fast</kbd>

          对应Max中的快速模式，使用USD导入，速度更快，但是对于软件版本有更高要求。

        + <kbd>Normal</kbd>

          对应Max中的兼容模式，使用FBX导入，速度比较慢，兼容大部分软件。

    2. Import Option 导入选项

        + <kbd>Model</kbd>

          勾选后，导入模型
        + <kbd>Light</kbd>

          勾选后，导入灯光

        + <kbd>Proxy</kbd>

          勾选后，导入代理物体

        + <kbd>Camera</kbd>

          勾选后，导入相机

        + <kbd>Material</kbd>

          勾选后，导入材质

        + <kbd>Settings</kbd>

          勾选后，自动设置为Max的渲染尺寸
    3. Others

        + Cycles Render
        自动切换为Cycles渲染，默认为选择状态
    
    4. Import Options

        + <kbd>Only Import</kbd>

          勾选后，仅导入3Ds Max端导出的内容或上次导出的内容（包括不打开Max软件自动转换的内容）。
          自动忽略文件路径。

    5. Import Max V.x.x.x
        点击后自动转换并导入模型

